"""
@generated by mypy-protobuf.  Do not edit manually!
isort:skip_file
"""
import builtins
import collections.abc
import google.protobuf.any_pb2
import google.protobuf.descriptor
import google.protobuf.internal.containers
import google.protobuf.internal.enum_type_wrapper
import google.protobuf.message
import google.protobuf.struct_pb2
import google.protobuf.timestamp_pb2
import sys
import typing
if sys.version_info >= (3, 10):
    import typing as typing_extensions
else:
    import typing_extensions
DESCRIPTOR: google.protobuf.descriptor.FileDescriptor

class _Order:
    ValueType = typing.NewType('ValueType', builtins.int)
    V: typing_extensions.TypeAlias = ValueType

class _OrderEnumTypeWrapper(google.protobuf.internal.enum_type_wrapper._EnumTypeWrapper[_Order.ValueType], builtins.type):
    DESCRIPTOR: google.protobuf.descriptor.EnumDescriptor
    ORDER_UNSPECIFIED: _Order.ValueType
    ORDER_DESCENDING: _Order.ValueType
    ORDER_ASCENDING: _Order.ValueType

class Order(_Order, metaclass=_OrderEnumTypeWrapper):
    """Order specifies the order in which data is returned."""
ORDER_UNSPECIFIED: Order.ValueType
ORDER_DESCENDING: Order.ValueType
ORDER_ASCENDING: Order.ValueType
global___Order = Order

class _TagsFilterType:
    ValueType = typing.NewType('ValueType', builtins.int)
    V: typing_extensions.TypeAlias = ValueType

class _TagsFilterTypeEnumTypeWrapper(google.protobuf.internal.enum_type_wrapper._EnumTypeWrapper[_TagsFilterType.ValueType], builtins.type):
    DESCRIPTOR: google.protobuf.descriptor.EnumDescriptor
    TAGS_FILTER_TYPE_UNSPECIFIED: _TagsFilterType.ValueType
    TAGS_FILTER_TYPE_MATCH_BY_OR: _TagsFilterType.ValueType
    'TAGS_FILTER_TYPE_MATCH_BY_OR specifies documents matched (using logical OR) on the tags field in the TagsFilter.'
    TAGS_FILTER_TYPE_TAGGED: _TagsFilterType.ValueType
    'TAGS_FILTER_TYPE_TAGGED specifies that all tagged documents should be returned.'
    TAGS_FILTER_TYPE_UNTAGGED: _TagsFilterType.ValueType
    'TAGS_FILTER_TYPE_UNTAGGED specifes that all untagged documents should be returned.'

class TagsFilterType(_TagsFilterType, metaclass=_TagsFilterTypeEnumTypeWrapper):
    """TagsFilterType specifies how data can be filtered based on tags."""
TAGS_FILTER_TYPE_UNSPECIFIED: TagsFilterType.ValueType
TAGS_FILTER_TYPE_MATCH_BY_OR: TagsFilterType.ValueType
'TAGS_FILTER_TYPE_MATCH_BY_OR specifies documents matched (using logical OR) on the tags field in the TagsFilter.'
TAGS_FILTER_TYPE_TAGGED: TagsFilterType.ValueType
'TAGS_FILTER_TYPE_TAGGED specifies that all tagged documents should be returned.'
TAGS_FILTER_TYPE_UNTAGGED: TagsFilterType.ValueType
'TAGS_FILTER_TYPE_UNTAGGED specifes that all untagged documents should be returned.'
global___TagsFilterType = TagsFilterType

class _TabularDataSourceType:
    ValueType = typing.NewType('ValueType', builtins.int)
    V: typing_extensions.TypeAlias = ValueType

class _TabularDataSourceTypeEnumTypeWrapper(google.protobuf.internal.enum_type_wrapper._EnumTypeWrapper[_TabularDataSourceType.ValueType], builtins.type):
    DESCRIPTOR: google.protobuf.descriptor.EnumDescriptor
    TABULAR_DATA_SOURCE_TYPE_UNSPECIFIED: _TabularDataSourceType.ValueType
    TABULAR_DATA_SOURCE_TYPE_STANDARD: _TabularDataSourceType.ValueType
    'TABULAR_DATA_SOURCE_TYPE_STANDARD indicates reading from standard storage. This is\n    the default option and available for all data synced to Viam.\n    '
    TABULAR_DATA_SOURCE_TYPE_HOT_STORAGE: _TabularDataSourceType.ValueType
    'TABULAR_DATA_SOURCE_TYPE_HOT_STORAGE indicates reading from hot storage. This is a\n    premium feature requiring opting in specific data sources.\n    See docs at https://docs.viam.com/data-ai/capture-data/advanced/advanced-data-capture-sync/#capture-to-the-hot-data-store\n    '
    TABULAR_DATA_SOURCE_TYPE_PIPELINE_SINK: _TabularDataSourceType.ValueType
    'TABULAR_DATA_SOURCE_TYPE_PIPELINE_SINK indicates reading the output data of\n    a data pipeline. When using this, a pipeline ID needs to be specified.\n    '

class TabularDataSourceType(_TabularDataSourceType, metaclass=_TabularDataSourceTypeEnumTypeWrapper):
    """TabularDataSourceType specifies the data source type for TabularDataByMQL queries."""
TABULAR_DATA_SOURCE_TYPE_UNSPECIFIED: TabularDataSourceType.ValueType
TABULAR_DATA_SOURCE_TYPE_STANDARD: TabularDataSourceType.ValueType
'TABULAR_DATA_SOURCE_TYPE_STANDARD indicates reading from standard storage. This is\nthe default option and available for all data synced to Viam.\n'
TABULAR_DATA_SOURCE_TYPE_HOT_STORAGE: TabularDataSourceType.ValueType
'TABULAR_DATA_SOURCE_TYPE_HOT_STORAGE indicates reading from hot storage. This is a\npremium feature requiring opting in specific data sources.\nSee docs at https://docs.viam.com/data-ai/capture-data/advanced/advanced-data-capture-sync/#capture-to-the-hot-data-store\n'
TABULAR_DATA_SOURCE_TYPE_PIPELINE_SINK: TabularDataSourceType.ValueType
'TABULAR_DATA_SOURCE_TYPE_PIPELINE_SINK indicates reading the output data of\na data pipeline. When using this, a pipeline ID needs to be specified.\n'
global___TabularDataSourceType = TabularDataSourceType

@typing.final
class DataRequest(google.protobuf.message.Message):
    """DataRequest encapsulates the filter for the data, a limit on the maximum results returned,
    a last string associated with the last returned document, and the sorting order by time.
    last is returned in the responses TabularDataByFilterResponse and BinaryDataByFilterResponse
    from the API calls TabularDataByFilter and BinaryDataByFilter, respectively.
    We can then use the last string from the previous API calls in the subsequent request
    to get the next set of ordered documents.
    """
    DESCRIPTOR: google.protobuf.descriptor.Descriptor
    FILTER_FIELD_NUMBER: builtins.int
    LIMIT_FIELD_NUMBER: builtins.int
    LAST_FIELD_NUMBER: builtins.int
    SORT_ORDER_FIELD_NUMBER: builtins.int
    limit: builtins.int
    last: builtins.str
    sort_order: global___Order.ValueType

    @property
    def filter(self) -> global___Filter:
        ...

    def __init__(self, *, filter: global___Filter | None=..., limit: builtins.int=..., last: builtins.str=..., sort_order: global___Order.ValueType=...) -> None:
        ...

    def HasField(self, field_name: typing.Literal['filter', b'filter']) -> builtins.bool:
        ...

    def ClearField(self, field_name: typing.Literal['filter', b'filter', 'last', b'last', 'limit', b'limit', 'sort_order', b'sort_order']) -> None:
        ...
global___DataRequest = DataRequest

@typing.final
class Filter(google.protobuf.message.Message):
    """Filter defines the fields over which we can filter data using a logic AND.
    For example, if component_type and robot_id are specified, only data from that `robot_id` of
    type `component_type` is returned. However, we logical OR over the specified tags and bounding
    box labels, such that if component_type, robot_id, tagA, tagB are specified,
    we return data from that `robot_id` of type `component_type` with `tagA` or `tagB`.
    """
    DESCRIPTOR: google.protobuf.descriptor.Descriptor
    COMPONENT_NAME_FIELD_NUMBER: builtins.int
    COMPONENT_TYPE_FIELD_NUMBER: builtins.int
    METHOD_FIELD_NUMBER: builtins.int
    ROBOT_NAME_FIELD_NUMBER: builtins.int
    ROBOT_ID_FIELD_NUMBER: builtins.int
    PART_NAME_FIELD_NUMBER: builtins.int
    PART_ID_FIELD_NUMBER: builtins.int
    LOCATION_IDS_FIELD_NUMBER: builtins.int
    ORGANIZATION_IDS_FIELD_NUMBER: builtins.int
    MIME_TYPE_FIELD_NUMBER: builtins.int
    INTERVAL_FIELD_NUMBER: builtins.int
    TAGS_FILTER_FIELD_NUMBER: builtins.int
    BBOX_LABELS_FIELD_NUMBER: builtins.int
    DATASET_ID_FIELD_NUMBER: builtins.int
    component_name: builtins.str
    component_type: builtins.str
    method: builtins.str
    robot_name: builtins.str
    robot_id: builtins.str
    part_name: builtins.str
    part_id: builtins.str
    dataset_id: builtins.str

    @property
    def location_ids(self) -> google.protobuf.internal.containers.RepeatedScalarFieldContainer[builtins.str]:
        ...

    @property
    def organization_ids(self) -> google.protobuf.internal.containers.RepeatedScalarFieldContainer[builtins.str]:
        ...

    @property
    def mime_type(self) -> google.protobuf.internal.containers.RepeatedScalarFieldContainer[builtins.str]:
        ...

    @property
    def interval(self) -> global___CaptureInterval:
        ...

    @property
    def tags_filter(self) -> global___TagsFilter:
        ...

    @property
    def bbox_labels(self) -> google.protobuf.internal.containers.RepeatedScalarFieldContainer[builtins.str]:
        """bbox_labels are used to match documents with the specified bounding box labels (using logical OR)."""

    def __init__(self, *, component_name: builtins.str=..., component_type: builtins.str=..., method: builtins.str=..., robot_name: builtins.str=..., robot_id: builtins.str=..., part_name: builtins.str=..., part_id: builtins.str=..., location_ids: collections.abc.Iterable[builtins.str] | None=..., organization_ids: collections.abc.Iterable[builtins.str] | None=..., mime_type: collections.abc.Iterable[builtins.str] | None=..., interval: global___CaptureInterval | None=..., tags_filter: global___TagsFilter | None=..., bbox_labels: collections.abc.Iterable[builtins.str] | None=..., dataset_id: builtins.str=...) -> None:
        ...

    def HasField(self, field_name: typing.Literal['interval', b'interval', 'tags_filter', b'tags_filter']) -> builtins.bool:
        ...

    def ClearField(self, field_name: typing.Literal['bbox_labels', b'bbox_labels', 'component_name', b'component_name', 'component_type', b'component_type', 'dataset_id', b'dataset_id', 'interval', b'interval', 'location_ids', b'location_ids', 'method', b'method', 'mime_type', b'mime_type', 'organization_ids', b'organization_ids', 'part_id', b'part_id', 'part_name', b'part_name', 'robot_id', b'robot_id', 'robot_name', b'robot_name', 'tags_filter', b'tags_filter']) -> None:
        ...
global___Filter = Filter

@typing.final
class TagsFilter(google.protobuf.message.Message):
    """TagsFilter defines the type of filtering and, if applicable, over which tags to perform a logical OR."""
    DESCRIPTOR: google.protobuf.descriptor.Descriptor
    TYPE_FIELD_NUMBER: builtins.int
    TAGS_FIELD_NUMBER: builtins.int
    type: global___TagsFilterType.ValueType

    @property
    def tags(self) -> google.protobuf.internal.containers.RepeatedScalarFieldContainer[builtins.str]:
        """Tags are used to match documents if `type` is UNSPECIFIED or MATCH_BY_OR."""

    def __init__(self, *, type: global___TagsFilterType.ValueType=..., tags: collections.abc.Iterable[builtins.str] | None=...) -> None:
        ...

    def ClearField(self, field_name: typing.Literal['tags', b'tags', 'type', b'type']) -> None:
        ...
global___TagsFilter = TagsFilter

@typing.final
class CaptureMetadata(google.protobuf.message.Message):
    """CaptureMetadata contains information on the settings used for the data capture."""
    DESCRIPTOR: google.protobuf.descriptor.Descriptor

    @typing.final
    class MethodParametersEntry(google.protobuf.message.Message):
        DESCRIPTOR: google.protobuf.descriptor.Descriptor
        KEY_FIELD_NUMBER: builtins.int
        VALUE_FIELD_NUMBER: builtins.int
        key: builtins.str

        @property
        def value(self) -> google.protobuf.any_pb2.Any:
            ...

        def __init__(self, *, key: builtins.str=..., value: google.protobuf.any_pb2.Any | None=...) -> None:
            ...

        def HasField(self, field_name: typing.Literal['value', b'value']) -> builtins.bool:
            ...

        def ClearField(self, field_name: typing.Literal['key', b'key', 'value', b'value']) -> None:
            ...
    ORGANIZATION_ID_FIELD_NUMBER: builtins.int
    LOCATION_ID_FIELD_NUMBER: builtins.int
    ROBOT_NAME_FIELD_NUMBER: builtins.int
    ROBOT_ID_FIELD_NUMBER: builtins.int
    PART_NAME_FIELD_NUMBER: builtins.int
    PART_ID_FIELD_NUMBER: builtins.int
    COMPONENT_TYPE_FIELD_NUMBER: builtins.int
    COMPONENT_NAME_FIELD_NUMBER: builtins.int
    METHOD_NAME_FIELD_NUMBER: builtins.int
    METHOD_PARAMETERS_FIELD_NUMBER: builtins.int
    TAGS_FIELD_NUMBER: builtins.int
    MIME_TYPE_FIELD_NUMBER: builtins.int
    organization_id: builtins.str
    location_id: builtins.str
    robot_name: builtins.str
    robot_id: builtins.str
    part_name: builtins.str
    part_id: builtins.str
    component_type: builtins.str
    component_name: builtins.str
    method_name: builtins.str
    mime_type: builtins.str

    @property
    def method_parameters(self) -> google.protobuf.internal.containers.MessageMap[builtins.str, google.protobuf.any_pb2.Any]:
        ...

    @property
    def tags(self) -> google.protobuf.internal.containers.RepeatedScalarFieldContainer[builtins.str]:
        ...

    def __init__(self, *, organization_id: builtins.str=..., location_id: builtins.str=..., robot_name: builtins.str=..., robot_id: builtins.str=..., part_name: builtins.str=..., part_id: builtins.str=..., component_type: builtins.str=..., component_name: builtins.str=..., method_name: builtins.str=..., method_parameters: collections.abc.Mapping[builtins.str, google.protobuf.any_pb2.Any] | None=..., tags: collections.abc.Iterable[builtins.str] | None=..., mime_type: builtins.str=...) -> None:
        ...

    def ClearField(self, field_name: typing.Literal['component_name', b'component_name', 'component_type', b'component_type', 'location_id', b'location_id', 'method_name', b'method_name', 'method_parameters', b'method_parameters', 'mime_type', b'mime_type', 'organization_id', b'organization_id', 'part_id', b'part_id', 'part_name', b'part_name', 'robot_id', b'robot_id', 'robot_name', b'robot_name', 'tags', b'tags']) -> None:
        ...
global___CaptureMetadata = CaptureMetadata

@typing.final
class CaptureInterval(google.protobuf.message.Message):
    """CaptureInterval describes the start and end time of the capture in this file."""
    DESCRIPTOR: google.protobuf.descriptor.Descriptor
    START_FIELD_NUMBER: builtins.int
    END_FIELD_NUMBER: builtins.int

    @property
    def start(self) -> google.protobuf.timestamp_pb2.Timestamp:
        ...

    @property
    def end(self) -> google.protobuf.timestamp_pb2.Timestamp:
        ...

    def __init__(self, *, start: google.protobuf.timestamp_pb2.Timestamp | None=..., end: google.protobuf.timestamp_pb2.Timestamp | None=...) -> None:
        ...

    def HasField(self, field_name: typing.Literal['end', b'end', 'start', b'start']) -> builtins.bool:
        ...

    def ClearField(self, field_name: typing.Literal['end', b'end', 'start', b'start']) -> None:
        ...
global___CaptureInterval = CaptureInterval

@typing.final
class TabularDataByFilterRequest(google.protobuf.message.Message):
    """TabularDataByFilterRequest requests tabular data based on filter values."""
    DESCRIPTOR: google.protobuf.descriptor.Descriptor
    DATA_REQUEST_FIELD_NUMBER: builtins.int
    COUNT_ONLY_FIELD_NUMBER: builtins.int
    INCLUDE_INTERNAL_DATA_FIELD_NUMBER: builtins.int
    count_only: builtins.bool
    include_internal_data: builtins.bool

    @property
    def data_request(self) -> global___DataRequest:
        ...

    def __init__(self, *, data_request: global___DataRequest | None=..., count_only: builtins.bool=..., include_internal_data: builtins.bool=...) -> None:
        ...

    def HasField(self, field_name: typing.Literal['data_request', b'data_request']) -> builtins.bool:
        ...

    def ClearField(self, field_name: typing.Literal['count_only', b'count_only', 'data_request', b'data_request', 'include_internal_data', b'include_internal_data']) -> None:
        ...
global___TabularDataByFilterRequest = TabularDataByFilterRequest

@typing.final
class TabularDataByFilterResponse(google.protobuf.message.Message):
    """TabularDataByFilterResponse provides the data and metadata of tabular data."""
    DESCRIPTOR: google.protobuf.descriptor.Descriptor
    METADATA_FIELD_NUMBER: builtins.int
    DATA_FIELD_NUMBER: builtins.int
    COUNT_FIELD_NUMBER: builtins.int
    LAST_FIELD_NUMBER: builtins.int
    TOTAL_SIZE_BYTES_FIELD_NUMBER: builtins.int
    count: builtins.int
    last: builtins.str
    total_size_bytes: builtins.int

    @property
    def metadata(self) -> google.protobuf.internal.containers.RepeatedCompositeFieldContainer[global___CaptureMetadata]:
        ...

    @property
    def data(self) -> google.protobuf.internal.containers.RepeatedCompositeFieldContainer[global___TabularData]:
        ...

    def __init__(self, *, metadata: collections.abc.Iterable[global___CaptureMetadata] | None=..., data: collections.abc.Iterable[global___TabularData] | None=..., count: builtins.int=..., last: builtins.str=..., total_size_bytes: builtins.int=...) -> None:
        ...

    def ClearField(self, field_name: typing.Literal['count', b'count', 'data', b'data', 'last', b'last', 'metadata', b'metadata', 'total_size_bytes', b'total_size_bytes']) -> None:
        ...
global___TabularDataByFilterResponse = TabularDataByFilterResponse

@typing.final
class TabularData(google.protobuf.message.Message):
    """TabularData contains data and metadata associated with tabular data."""
    DESCRIPTOR: google.protobuf.descriptor.Descriptor
    DATA_FIELD_NUMBER: builtins.int
    METADATA_INDEX_FIELD_NUMBER: builtins.int
    TIME_REQUESTED_FIELD_NUMBER: builtins.int
    TIME_RECEIVED_FIELD_NUMBER: builtins.int
    metadata_index: builtins.int

    @property
    def data(self) -> google.protobuf.struct_pb2.Struct:
        ...

    @property
    def time_requested(self) -> google.protobuf.timestamp_pb2.Timestamp:
        ...

    @property
    def time_received(self) -> google.protobuf.timestamp_pb2.Timestamp:
        ...

    def __init__(self, *, data: google.protobuf.struct_pb2.Struct | None=..., metadata_index: builtins.int=..., time_requested: google.protobuf.timestamp_pb2.Timestamp | None=..., time_received: google.protobuf.timestamp_pb2.Timestamp | None=...) -> None:
        ...

    def HasField(self, field_name: typing.Literal['data', b'data', 'time_received', b'time_received', 'time_requested', b'time_requested']) -> builtins.bool:
        ...

    def ClearField(self, field_name: typing.Literal['data', b'data', 'metadata_index', b'metadata_index', 'time_received', b'time_received', 'time_requested', b'time_requested']) -> None:
        ...
global___TabularData = TabularData

@typing.final
class TabularDataBySQLRequest(google.protobuf.message.Message):
    """TabularDataBySQLRequest requests tabular data using a SQL query."""
    DESCRIPTOR: google.protobuf.descriptor.Descriptor
    ORGANIZATION_ID_FIELD_NUMBER: builtins.int
    SQL_QUERY_FIELD_NUMBER: builtins.int
    organization_id: builtins.str
    sql_query: builtins.str
    'sql_query accepts any valid SQL SELECT statement. Tabular data is held in a database\n    called "sensorData" and a table called readings, so queries should select from "readings"\n    or "sensorData.readings".\n    '

    def __init__(self, *, organization_id: builtins.str=..., sql_query: builtins.str=...) -> None:
        ...

    def ClearField(self, field_name: typing.Literal['organization_id', b'organization_id', 'sql_query', b'sql_query']) -> None:
        ...
global___TabularDataBySQLRequest = TabularDataBySQLRequest

@typing.final
class TabularDataBySQLResponse(google.protobuf.message.Message):
    """TabularDataBySQLResponse provides unified tabular data and metadata, queried with SQL."""
    DESCRIPTOR: google.protobuf.descriptor.Descriptor
    RAW_DATA_FIELD_NUMBER: builtins.int

    @property
    def raw_data(self) -> google.protobuf.internal.containers.RepeatedScalarFieldContainer[builtins.bytes]:
        ...

    def __init__(self, *, raw_data: collections.abc.Iterable[builtins.bytes] | None=...) -> None:
        ...

    def ClearField(self, field_name: typing.Literal['raw_data', b'raw_data']) -> None:
        ...
global___TabularDataBySQLResponse = TabularDataBySQLResponse

@typing.final
class TabularDataSource(google.protobuf.message.Message):
    """TabularDataSource specifies the data source for user queries to execute on."""
    DESCRIPTOR: google.protobuf.descriptor.Descriptor
    TYPE_FIELD_NUMBER: builtins.int
    PIPELINE_ID_FIELD_NUMBER: builtins.int
    type: global___TabularDataSourceType.ValueType
    pipeline_id: builtins.str
    'pipeline_id is the ID of the pipeline to query. Required when using\n    TABULAR_DATA_SOURCE_TYPE_PIPELINE_SINK.\n    '

    def __init__(self, *, type: global___TabularDataSourceType.ValueType=..., pipeline_id: builtins.str | None=...) -> None:
        ...

    def HasField(self, field_name: typing.Literal['_pipeline_id', b'_pipeline_id', 'pipeline_id', b'pipeline_id']) -> builtins.bool:
        ...

    def ClearField(self, field_name: typing.Literal['_pipeline_id', b'_pipeline_id', 'pipeline_id', b'pipeline_id', 'type', b'type']) -> None:
        ...

    def WhichOneof(self, oneof_group: typing.Literal['_pipeline_id', b'_pipeline_id']) -> typing.Literal['pipeline_id'] | None:
        ...
global___TabularDataSource = TabularDataSource

@typing.final
class TabularDataByMQLRequest(google.protobuf.message.Message):
    """TabularDataByMQLRequest requests tabular data using an MQL query."""
    DESCRIPTOR: google.protobuf.descriptor.Descriptor
    ORGANIZATION_ID_FIELD_NUMBER: builtins.int
    MQL_BINARY_FIELD_NUMBER: builtins.int
    USE_RECENT_DATA_FIELD_NUMBER: builtins.int
    DATA_SOURCE_FIELD_NUMBER: builtins.int
    organization_id: builtins.str
    use_recent_data: builtins.bool
    'Deprecated, please use TABULAR_DATA_SOURCE_TYPE_HOT_STORAGE instead.'

    @property
    def mql_binary(self) -> google.protobuf.internal.containers.RepeatedScalarFieldContainer[builtins.bytes]:
        """mql_binary accepts a MongoDB aggregation pipeline as a list of BSON documents, where each
        document is one stage in the pipeline. The pipeline is run on the "sensorData.readings"
        namespace, which holds the Viam organization's tabular data.
        """

    @property
    def data_source(self) -> global___TabularDataSource:
        """data_source is an optional field that can be used to specify the data source for the query.
        If not specified, the query will run on "standard" storage.
        """

    def __init__(self, *, organization_id: builtins.str=..., mql_binary: collections.abc.Iterable[builtins.bytes] | None=..., use_recent_data: builtins.bool | None=..., data_source: global___TabularDataSource | None=...) -> None:
        ...

    def HasField(self, field_name: typing.Literal['_data_source', b'_data_source', '_use_recent_data', b'_use_recent_data', 'data_source', b'data_source', 'use_recent_data', b'use_recent_data']) -> builtins.bool:
        ...

    def ClearField(self, field_name: typing.Literal['_data_source', b'_data_source', '_use_recent_data', b'_use_recent_data', 'data_source', b'data_source', 'mql_binary', b'mql_binary', 'organization_id', b'organization_id', 'use_recent_data', b'use_recent_data']) -> None:
        ...

    @typing.overload
    def WhichOneof(self, oneof_group: typing.Literal['_data_source', b'_data_source']) -> typing.Literal['data_source'] | None:
        ...

    @typing.overload
    def WhichOneof(self, oneof_group: typing.Literal['_use_recent_data', b'_use_recent_data']) -> typing.Literal['use_recent_data'] | None:
        ...
global___TabularDataByMQLRequest = TabularDataByMQLRequest

@typing.final
class TabularDataByMQLResponse(google.protobuf.message.Message):
    """TabularDataByMQLResponse provides unified tabular data and metadata, queried with MQL."""
    DESCRIPTOR: google.protobuf.descriptor.Descriptor
    RAW_DATA_FIELD_NUMBER: builtins.int

    @property
    def raw_data(self) -> google.protobuf.internal.containers.RepeatedScalarFieldContainer[builtins.bytes]:
        ...

    def __init__(self, *, raw_data: collections.abc.Iterable[builtins.bytes] | None=...) -> None:
        ...

    def ClearField(self, field_name: typing.Literal['raw_data', b'raw_data']) -> None:
        ...
global___TabularDataByMQLResponse = TabularDataByMQLResponse

@typing.final
class ExportTabularDataRequest(google.protobuf.message.Message):
    """ExportTabularDataRequest requests tabular data from the specified data source."""
    DESCRIPTOR: google.protobuf.descriptor.Descriptor
    PART_ID_FIELD_NUMBER: builtins.int
    RESOURCE_NAME_FIELD_NUMBER: builtins.int
    RESOURCE_SUBTYPE_FIELD_NUMBER: builtins.int
    METHOD_NAME_FIELD_NUMBER: builtins.int
    INTERVAL_FIELD_NUMBER: builtins.int
    part_id: builtins.str
    resource_name: builtins.str
    resource_subtype: builtins.str
    method_name: builtins.str

    @property
    def interval(self) -> global___CaptureInterval:
        ...

    def __init__(self, *, part_id: builtins.str=..., resource_name: builtins.str=..., resource_subtype: builtins.str=..., method_name: builtins.str=..., interval: global___CaptureInterval | None=...) -> None:
        ...

    def HasField(self, field_name: typing.Literal['interval', b'interval']) -> builtins.bool:
        ...

    def ClearField(self, field_name: typing.Literal['interval', b'interval', 'method_name', b'method_name', 'part_id', b'part_id', 'resource_name', b'resource_name', 'resource_subtype', b'resource_subtype']) -> None:
        ...
global___ExportTabularDataRequest = ExportTabularDataRequest

@typing.final
class ExportTabularDataResponse(google.protobuf.message.Message):
    """ExportTabularDataResponse provides unified tabular data and metadata for a single data point from the specified data source."""
    DESCRIPTOR: google.protobuf.descriptor.Descriptor
    PART_ID_FIELD_NUMBER: builtins.int
    RESOURCE_NAME_FIELD_NUMBER: builtins.int
    RESOURCE_SUBTYPE_FIELD_NUMBER: builtins.int
    METHOD_NAME_FIELD_NUMBER: builtins.int
    TIME_CAPTURED_FIELD_NUMBER: builtins.int
    ORGANIZATION_ID_FIELD_NUMBER: builtins.int
    LOCATION_ID_FIELD_NUMBER: builtins.int
    ROBOT_NAME_FIELD_NUMBER: builtins.int
    ROBOT_ID_FIELD_NUMBER: builtins.int
    PART_NAME_FIELD_NUMBER: builtins.int
    METHOD_PARAMETERS_FIELD_NUMBER: builtins.int
    TAGS_FIELD_NUMBER: builtins.int
    PAYLOAD_FIELD_NUMBER: builtins.int
    part_id: builtins.str
    resource_name: builtins.str
    resource_subtype: builtins.str
    method_name: builtins.str
    organization_id: builtins.str
    location_id: builtins.str
    robot_name: builtins.str
    robot_id: builtins.str
    part_name: builtins.str

    @property
    def time_captured(self) -> google.protobuf.timestamp_pb2.Timestamp:
        ...

    @property
    def method_parameters(self) -> google.protobuf.struct_pb2.Struct:
        ...

    @property
    def tags(self) -> google.protobuf.internal.containers.RepeatedScalarFieldContainer[builtins.str]:
        ...

    @property
    def payload(self) -> google.protobuf.struct_pb2.Struct:
        ...

    def __init__(self, *, part_id: builtins.str=..., resource_name: builtins.str=..., resource_subtype: builtins.str=..., method_name: builtins.str=..., time_captured: google.protobuf.timestamp_pb2.Timestamp | None=..., organization_id: builtins.str=..., location_id: builtins.str=..., robot_name: builtins.str=..., robot_id: builtins.str=..., part_name: builtins.str=..., method_parameters: google.protobuf.struct_pb2.Struct | None=..., tags: collections.abc.Iterable[builtins.str] | None=..., payload: google.protobuf.struct_pb2.Struct | None=...) -> None:
        ...

    def HasField(self, field_name: typing.Literal['method_parameters', b'method_parameters', 'payload', b'payload', 'time_captured', b'time_captured']) -> builtins.bool:
        ...

    def ClearField(self, field_name: typing.Literal['location_id', b'location_id', 'method_name', b'method_name', 'method_parameters', b'method_parameters', 'organization_id', b'organization_id', 'part_id', b'part_id', 'part_name', b'part_name', 'payload', b'payload', 'resource_name', b'resource_name', 'resource_subtype', b'resource_subtype', 'robot_id', b'robot_id', 'robot_name', b'robot_name', 'tags', b'tags', 'time_captured', b'time_captured']) -> None:
        ...
global___ExportTabularDataResponse = ExportTabularDataResponse

@typing.final
class GetLatestTabularDataRequest(google.protobuf.message.Message):
    """GetLatestTabularDataRequest requests the most recent tabular data captured from the specified data source."""
    DESCRIPTOR: google.protobuf.descriptor.Descriptor
    PART_ID_FIELD_NUMBER: builtins.int
    RESOURCE_NAME_FIELD_NUMBER: builtins.int
    METHOD_NAME_FIELD_NUMBER: builtins.int
    RESOURCE_SUBTYPE_FIELD_NUMBER: builtins.int
    part_id: builtins.str
    resource_name: builtins.str
    method_name: builtins.str
    resource_subtype: builtins.str

    def __init__(self, *, part_id: builtins.str=..., resource_name: builtins.str=..., method_name: builtins.str=..., resource_subtype: builtins.str=...) -> None:
        ...

    def ClearField(self, field_name: typing.Literal['method_name', b'method_name', 'part_id', b'part_id', 'resource_name', b'resource_name', 'resource_subtype', b'resource_subtype']) -> None:
        ...
global___GetLatestTabularDataRequest = GetLatestTabularDataRequest

@typing.final
class GetLatestTabularDataResponse(google.protobuf.message.Message):
    """GetLatestTabularDataResponse provides the data, time synced, and time captured of the most recent tabular data captured
    from the requested data source, as long as it was synced within the last year.
    """
    DESCRIPTOR: google.protobuf.descriptor.Descriptor
    TIME_CAPTURED_FIELD_NUMBER: builtins.int
    TIME_SYNCED_FIELD_NUMBER: builtins.int
    PAYLOAD_FIELD_NUMBER: builtins.int

    @property
    def time_captured(self) -> google.protobuf.timestamp_pb2.Timestamp:
        ...

    @property
    def time_synced(self) -> google.protobuf.timestamp_pb2.Timestamp:
        ...

    @property
    def payload(self) -> google.protobuf.struct_pb2.Struct:
        ...

    def __init__(self, *, time_captured: google.protobuf.timestamp_pb2.Timestamp | None=..., time_synced: google.protobuf.timestamp_pb2.Timestamp | None=..., payload: google.protobuf.struct_pb2.Struct | None=...) -> None:
        ...

    def HasField(self, field_name: typing.Literal['payload', b'payload', 'time_captured', b'time_captured', 'time_synced', b'time_synced']) -> builtins.bool:
        ...

    def ClearField(self, field_name: typing.Literal['payload', b'payload', 'time_captured', b'time_captured', 'time_synced', b'time_synced']) -> None:
        ...
global___GetLatestTabularDataResponse = GetLatestTabularDataResponse

@typing.final
class BinaryData(google.protobuf.message.Message):
    """BinaryData contains data and metadata associated with binary data."""
    DESCRIPTOR: google.protobuf.descriptor.Descriptor
    BINARY_FIELD_NUMBER: builtins.int
    METADATA_FIELD_NUMBER: builtins.int
    binary: builtins.bytes

    @property
    def metadata(self) -> global___BinaryMetadata:
        ...

    def __init__(self, *, binary: builtins.bytes=..., metadata: global___BinaryMetadata | None=...) -> None:
        ...

    def HasField(self, field_name: typing.Literal['metadata', b'metadata']) -> builtins.bool:
        ...

    def ClearField(self, field_name: typing.Literal['binary', b'binary', 'metadata', b'metadata']) -> None:
        ...
global___BinaryData = BinaryData

@typing.final
class BinaryDataByFilterRequest(google.protobuf.message.Message):
    """BinaryDataByFilterRequest requests the data and metadata of binary (image + file) data when a filter is provided."""
    DESCRIPTOR: google.protobuf.descriptor.Descriptor
    DATA_REQUEST_FIELD_NUMBER: builtins.int
    INCLUDE_BINARY_FIELD_NUMBER: builtins.int
    COUNT_ONLY_FIELD_NUMBER: builtins.int
    INCLUDE_INTERNAL_DATA_FIELD_NUMBER: builtins.int
    include_binary: builtins.bool
    count_only: builtins.bool
    include_internal_data: builtins.bool

    @property
    def data_request(self) -> global___DataRequest:
        ...

    def __init__(self, *, data_request: global___DataRequest | None=..., include_binary: builtins.bool=..., count_only: builtins.bool=..., include_internal_data: builtins.bool=...) -> None:
        ...

    def HasField(self, field_name: typing.Literal['data_request', b'data_request']) -> builtins.bool:
        ...

    def ClearField(self, field_name: typing.Literal['count_only', b'count_only', 'data_request', b'data_request', 'include_binary', b'include_binary', 'include_internal_data', b'include_internal_data']) -> None:
        ...
global___BinaryDataByFilterRequest = BinaryDataByFilterRequest

@typing.final
class BinaryDataByFilterResponse(google.protobuf.message.Message):
    """BinaryDataByFilterResponse provides the data and metadata of binary (image + file) data when a filter is provided."""
    DESCRIPTOR: google.protobuf.descriptor.Descriptor
    DATA_FIELD_NUMBER: builtins.int
    COUNT_FIELD_NUMBER: builtins.int
    LAST_FIELD_NUMBER: builtins.int
    TOTAL_SIZE_BYTES_FIELD_NUMBER: builtins.int
    count: builtins.int
    last: builtins.str
    total_size_bytes: builtins.int

    @property
    def data(self) -> google.protobuf.internal.containers.RepeatedCompositeFieldContainer[global___BinaryData]:
        ...

    def __init__(self, *, data: collections.abc.Iterable[global___BinaryData] | None=..., count: builtins.int=..., last: builtins.str=..., total_size_bytes: builtins.int=...) -> None:
        ...

    def ClearField(self, field_name: typing.Literal['count', b'count', 'data', b'data', 'last', b'last', 'total_size_bytes', b'total_size_bytes']) -> None:
        ...
global___BinaryDataByFilterResponse = BinaryDataByFilterResponse

@typing.final
class BinaryID(google.protobuf.message.Message):
    """BinaryID is the unique identifier for a file that one can request to be retrieved or modified."""
    DESCRIPTOR: google.protobuf.descriptor.Descriptor
    FILE_ID_FIELD_NUMBER: builtins.int
    ORGANIZATION_ID_FIELD_NUMBER: builtins.int
    LOCATION_ID_FIELD_NUMBER: builtins.int
    file_id: builtins.str
    organization_id: builtins.str
    location_id: builtins.str

    def __init__(self, *, file_id: builtins.str=..., organization_id: builtins.str=..., location_id: builtins.str=...) -> None:
        ...

    def ClearField(self, field_name: typing.Literal['file_id', b'file_id', 'location_id', b'location_id', 'organization_id', b'organization_id']) -> None:
        ...
global___BinaryID = BinaryID

@typing.final
class BinaryDataByIDsRequest(google.protobuf.message.Message):
    """BinaryDataByFilterRequest requests the data and metadata of binary (image + file) data by binary ids."""
    DESCRIPTOR: google.protobuf.descriptor.Descriptor
    INCLUDE_BINARY_FIELD_NUMBER: builtins.int
    BINARY_IDS_FIELD_NUMBER: builtins.int
    BINARY_DATA_IDS_FIELD_NUMBER: builtins.int
    include_binary: builtins.bool

    @property
    def binary_ids(self) -> google.protobuf.internal.containers.RepeatedCompositeFieldContainer[global___BinaryID]:
        ...

    @property
    def binary_data_ids(self) -> google.protobuf.internal.containers.RepeatedScalarFieldContainer[builtins.str]:
        ...

    def __init__(self, *, include_binary: builtins.bool=..., binary_ids: collections.abc.Iterable[global___BinaryID] | None=..., binary_data_ids: collections.abc.Iterable[builtins.str] | None=...) -> None:
        ...

    def ClearField(self, field_name: typing.Literal['binary_data_ids', b'binary_data_ids', 'binary_ids', b'binary_ids', 'include_binary', b'include_binary']) -> None:
        ...
global___BinaryDataByIDsRequest = BinaryDataByIDsRequest

@typing.final
class BinaryDataByIDsResponse(google.protobuf.message.Message):
    """BinaryDataByIDsResponse provides the data and metadata of binary (image + file) data when a filter is provided."""
    DESCRIPTOR: google.protobuf.descriptor.Descriptor
    DATA_FIELD_NUMBER: builtins.int
    COUNT_FIELD_NUMBER: builtins.int
    count: builtins.int

    @property
    def data(self) -> google.protobuf.internal.containers.RepeatedCompositeFieldContainer[global___BinaryData]:
        ...

    def __init__(self, *, data: collections.abc.Iterable[global___BinaryData] | None=..., count: builtins.int=...) -> None:
        ...

    def ClearField(self, field_name: typing.Literal['count', b'count', 'data', b'data']) -> None:
        ...
global___BinaryDataByIDsResponse = BinaryDataByIDsResponse

@typing.final
class BoundingBox(google.protobuf.message.Message):
    """BoundingBox represents a labeled bounding box on an image.
    x and y values are normalized ratios between 0 and 1.
    """
    DESCRIPTOR: google.protobuf.descriptor.Descriptor
    ID_FIELD_NUMBER: builtins.int
    LABEL_FIELD_NUMBER: builtins.int
    X_MIN_NORMALIZED_FIELD_NUMBER: builtins.int
    Y_MIN_NORMALIZED_FIELD_NUMBER: builtins.int
    X_MAX_NORMALIZED_FIELD_NUMBER: builtins.int
    Y_MAX_NORMALIZED_FIELD_NUMBER: builtins.int
    CONFIDENCE_FIELD_NUMBER: builtins.int
    id: builtins.str
    label: builtins.str
    x_min_normalized: builtins.float
    y_min_normalized: builtins.float
    x_max_normalized: builtins.float
    y_max_normalized: builtins.float
    confidence: builtins.float
    'confidence is an optional range from 0 - 1'

    def __init__(self, *, id: builtins.str=..., label: builtins.str=..., x_min_normalized: builtins.float=..., y_min_normalized: builtins.float=..., x_max_normalized: builtins.float=..., y_max_normalized: builtins.float=..., confidence: builtins.float | None=...) -> None:
        ...

    def HasField(self, field_name: typing.Literal['_confidence', b'_confidence', 'confidence', b'confidence']) -> builtins.bool:
        ...

    def ClearField(self, field_name: typing.Literal['_confidence', b'_confidence', 'confidence', b'confidence', 'id', b'id', 'label', b'label', 'x_max_normalized', b'x_max_normalized', 'x_min_normalized', b'x_min_normalized', 'y_max_normalized', b'y_max_normalized', 'y_min_normalized', b'y_min_normalized']) -> None:
        ...

    def WhichOneof(self, oneof_group: typing.Literal['_confidence', b'_confidence']) -> typing.Literal['confidence'] | None:
        ...
global___BoundingBox = BoundingBox

@typing.final
class Classification(google.protobuf.message.Message):
    """Classification represents a confidence score with a label."""
    DESCRIPTOR: google.protobuf.descriptor.Descriptor
    LABEL_FIELD_NUMBER: builtins.int
    CONFIDENCE_FIELD_NUMBER: builtins.int
    label: builtins.str
    confidence: builtins.float
    'confidence is an optional range from 0 - 1'

    def __init__(self, *, label: builtins.str=..., confidence: builtins.float | None=...) -> None:
        ...

    def HasField(self, field_name: typing.Literal['_confidence', b'_confidence', 'confidence', b'confidence']) -> builtins.bool:
        ...

    def ClearField(self, field_name: typing.Literal['_confidence', b'_confidence', 'confidence', b'confidence', 'label', b'label']) -> None:
        ...

    def WhichOneof(self, oneof_group: typing.Literal['_confidence', b'_confidence']) -> typing.Literal['confidence'] | None:
        ...
global___Classification = Classification

@typing.final
class Annotations(google.protobuf.message.Message):
    """Annotations are data annotations used for machine learning."""
    DESCRIPTOR: google.protobuf.descriptor.Descriptor
    BBOXES_FIELD_NUMBER: builtins.int
    CLASSIFICATIONS_FIELD_NUMBER: builtins.int

    @property
    def bboxes(self) -> google.protobuf.internal.containers.RepeatedCompositeFieldContainer[global___BoundingBox]:
        ...

    @property
    def classifications(self) -> google.protobuf.internal.containers.RepeatedCompositeFieldContainer[global___Classification]:
        ...

    def __init__(self, *, bboxes: collections.abc.Iterable[global___BoundingBox] | None=..., classifications: collections.abc.Iterable[global___Classification] | None=...) -> None:
        ...

    def ClearField(self, field_name: typing.Literal['bboxes', b'bboxes', 'classifications', b'classifications']) -> None:
        ...
global___Annotations = Annotations

@typing.final
class BinaryMetadata(google.protobuf.message.Message):
    """BinaryMetadata is the metadata associated with binary data."""
    DESCRIPTOR: google.protobuf.descriptor.Descriptor
    ID_FIELD_NUMBER: builtins.int
    CAPTURE_METADATA_FIELD_NUMBER: builtins.int
    TIME_REQUESTED_FIELD_NUMBER: builtins.int
    TIME_RECEIVED_FIELD_NUMBER: builtins.int
    FILE_NAME_FIELD_NUMBER: builtins.int
    FILE_EXT_FIELD_NUMBER: builtins.int
    URI_FIELD_NUMBER: builtins.int
    ANNOTATIONS_FIELD_NUMBER: builtins.int
    DATASET_IDS_FIELD_NUMBER: builtins.int
    BINARY_DATA_ID_FIELD_NUMBER: builtins.int
    id: builtins.str
    file_name: builtins.str
    file_ext: builtins.str
    uri: builtins.str
    binary_data_id: builtins.str

    @property
    def capture_metadata(self) -> global___CaptureMetadata:
        ...

    @property
    def time_requested(self) -> google.protobuf.timestamp_pb2.Timestamp:
        ...

    @property
    def time_received(self) -> google.protobuf.timestamp_pb2.Timestamp:
        ...

    @property
    def annotations(self) -> global___Annotations:
        ...

    @property
    def dataset_ids(self) -> google.protobuf.internal.containers.RepeatedScalarFieldContainer[builtins.str]:
        ...

    def __init__(self, *, id: builtins.str=..., capture_metadata: global___CaptureMetadata | None=..., time_requested: google.protobuf.timestamp_pb2.Timestamp | None=..., time_received: google.protobuf.timestamp_pb2.Timestamp | None=..., file_name: builtins.str=..., file_ext: builtins.str=..., uri: builtins.str=..., annotations: global___Annotations | None=..., dataset_ids: collections.abc.Iterable[builtins.str] | None=..., binary_data_id: builtins.str=...) -> None:
        ...

    def HasField(self, field_name: typing.Literal['annotations', b'annotations', 'capture_metadata', b'capture_metadata', 'time_received', b'time_received', 'time_requested', b'time_requested']) -> builtins.bool:
        ...

    def ClearField(self, field_name: typing.Literal['annotations', b'annotations', 'binary_data_id', b'binary_data_id', 'capture_metadata', b'capture_metadata', 'dataset_ids', b'dataset_ids', 'file_ext', b'file_ext', 'file_name', b'file_name', 'id', b'id', 'time_received', b'time_received', 'time_requested', b'time_requested', 'uri', b'uri']) -> None:
        ...
global___BinaryMetadata = BinaryMetadata

@typing.final
class DeleteTabularDataRequest(google.protobuf.message.Message):
    """DeleteTabularDataRequest deletes the data from the organization that is older than `delete_older_than_days`
    in UTC time. For example, if delete_older_than_days=1 and the request is made at 1AM EST on March 11
    (March 11 5AM UTC), this deletes all data captured through March 10 11:59:59PM UTC.
    If the request is at 10PM EST on March 11 (March 12 2AM UTC), this deletes all data captured
    through March 11 11:59:59PM UTC.
    If delete_older_than_days is 0, all existing data is deleted.
    """
    DESCRIPTOR: google.protobuf.descriptor.Descriptor
    ORGANIZATION_ID_FIELD_NUMBER: builtins.int
    DELETE_OLDER_THAN_DAYS_FIELD_NUMBER: builtins.int
    organization_id: builtins.str
    delete_older_than_days: builtins.int

    def __init__(self, *, organization_id: builtins.str=..., delete_older_than_days: builtins.int=...) -> None:
        ...

    def ClearField(self, field_name: typing.Literal['delete_older_than_days', b'delete_older_than_days', 'organization_id', b'organization_id']) -> None:
        ...
global___DeleteTabularDataRequest = DeleteTabularDataRequest

@typing.final
class DeleteTabularDataResponse(google.protobuf.message.Message):
    """DeleteBinaryDataResponse returns the number of tabular datapoints deleted."""
    DESCRIPTOR: google.protobuf.descriptor.Descriptor
    DELETED_COUNT_FIELD_NUMBER: builtins.int
    deleted_count: builtins.int

    def __init__(self, *, deleted_count: builtins.int=...) -> None:
        ...

    def ClearField(self, field_name: typing.Literal['deleted_count', b'deleted_count']) -> None:
        ...
global___DeleteTabularDataResponse = DeleteTabularDataResponse

@typing.final
class DeleteBinaryDataByFilterRequest(google.protobuf.message.Message):
    """DeleteBinaryDataByFilterRequest deletes the data and metadata of binary data when a filter is provided."""
    DESCRIPTOR: google.protobuf.descriptor.Descriptor
    FILTER_FIELD_NUMBER: builtins.int
    INCLUDE_INTERNAL_DATA_FIELD_NUMBER: builtins.int
    include_internal_data: builtins.bool

    @property
    def filter(self) -> global___Filter:
        ...

    def __init__(self, *, filter: global___Filter | None=..., include_internal_data: builtins.bool=...) -> None:
        ...

    def HasField(self, field_name: typing.Literal['filter', b'filter']) -> builtins.bool:
        ...

    def ClearField(self, field_name: typing.Literal['filter', b'filter', 'include_internal_data', b'include_internal_data']) -> None:
        ...
global___DeleteBinaryDataByFilterRequest = DeleteBinaryDataByFilterRequest

@typing.final
class DeleteBinaryDataByFilterResponse(google.protobuf.message.Message):
    """DeleteBinaryDataByFilterResponse returns the number of binary files deleted when a filter is provided."""
    DESCRIPTOR: google.protobuf.descriptor.Descriptor
    DELETED_COUNT_FIELD_NUMBER: builtins.int
    deleted_count: builtins.int

    def __init__(self, *, deleted_count: builtins.int=...) -> None:
        ...

    def ClearField(self, field_name: typing.Literal['deleted_count', b'deleted_count']) -> None:
        ...
global___DeleteBinaryDataByFilterResponse = DeleteBinaryDataByFilterResponse

@typing.final
class DeleteBinaryDataByIDsRequest(google.protobuf.message.Message):
    """DeleteBinaryDataByIDsRequest deletes the data and metadata of binary data when binary ids are provided."""
    DESCRIPTOR: google.protobuf.descriptor.Descriptor
    BINARY_IDS_FIELD_NUMBER: builtins.int
    BINARY_DATA_IDS_FIELD_NUMBER: builtins.int

    @property
    def binary_ids(self) -> google.protobuf.internal.containers.RepeatedCompositeFieldContainer[global___BinaryID]:
        ...

    @property
    def binary_data_ids(self) -> google.protobuf.internal.containers.RepeatedScalarFieldContainer[builtins.str]:
        ...

    def __init__(self, *, binary_ids: collections.abc.Iterable[global___BinaryID] | None=..., binary_data_ids: collections.abc.Iterable[builtins.str] | None=...) -> None:
        ...

    def ClearField(self, field_name: typing.Literal['binary_data_ids', b'binary_data_ids', 'binary_ids', b'binary_ids']) -> None:
        ...
global___DeleteBinaryDataByIDsRequest = DeleteBinaryDataByIDsRequest

@typing.final
class DeleteBinaryDataByIDsResponse(google.protobuf.message.Message):
    """DeleteBinaryDataByIDsResponse returns the number of binary files deleted when binary ids are provided."""
    DESCRIPTOR: google.protobuf.descriptor.Descriptor
    DELETED_COUNT_FIELD_NUMBER: builtins.int
    deleted_count: builtins.int

    def __init__(self, *, deleted_count: builtins.int=...) -> None:
        ...

    def ClearField(self, field_name: typing.Literal['deleted_count', b'deleted_count']) -> None:
        ...
global___DeleteBinaryDataByIDsResponse = DeleteBinaryDataByIDsResponse

@typing.final
class AddTagsToBinaryDataByIDsRequest(google.protobuf.message.Message):
    """AddTagsToBinaryDataByIDsRequest requests adding all specified tags to each of the files when binary ids are provided."""
    DESCRIPTOR: google.protobuf.descriptor.Descriptor
    BINARY_IDS_FIELD_NUMBER: builtins.int
    BINARY_DATA_IDS_FIELD_NUMBER: builtins.int
    TAGS_FIELD_NUMBER: builtins.int

    @property
    def binary_ids(self) -> google.protobuf.internal.containers.RepeatedCompositeFieldContainer[global___BinaryID]:
        ...

    @property
    def binary_data_ids(self) -> google.protobuf.internal.containers.RepeatedScalarFieldContainer[builtins.str]:
        ...

    @property
    def tags(self) -> google.protobuf.internal.containers.RepeatedScalarFieldContainer[builtins.str]:
        ...

    def __init__(self, *, binary_ids: collections.abc.Iterable[global___BinaryID] | None=..., binary_data_ids: collections.abc.Iterable[builtins.str] | None=..., tags: collections.abc.Iterable[builtins.str] | None=...) -> None:
        ...

    def ClearField(self, field_name: typing.Literal['binary_data_ids', b'binary_data_ids', 'binary_ids', b'binary_ids', 'tags', b'tags']) -> None:
        ...
global___AddTagsToBinaryDataByIDsRequest = AddTagsToBinaryDataByIDsRequest

@typing.final
class AddTagsToBinaryDataByIDsResponse(google.protobuf.message.Message):
    DESCRIPTOR: google.protobuf.descriptor.Descriptor

    def __init__(self) -> None:
        ...
global___AddTagsToBinaryDataByIDsResponse = AddTagsToBinaryDataByIDsResponse

@typing.final
class AddTagsToBinaryDataByFilterRequest(google.protobuf.message.Message):
    """AddTagsToBinaryDataByFilterRequest requests adding all specified tags to each of the files when a filter is provided."""
    DESCRIPTOR: google.protobuf.descriptor.Descriptor
    FILTER_FIELD_NUMBER: builtins.int
    TAGS_FIELD_NUMBER: builtins.int

    @property
    def filter(self) -> global___Filter:
        ...

    @property
    def tags(self) -> google.protobuf.internal.containers.RepeatedScalarFieldContainer[builtins.str]:
        ...

    def __init__(self, *, filter: global___Filter | None=..., tags: collections.abc.Iterable[builtins.str] | None=...) -> None:
        ...

    def HasField(self, field_name: typing.Literal['filter', b'filter']) -> builtins.bool:
        ...

    def ClearField(self, field_name: typing.Literal['filter', b'filter', 'tags', b'tags']) -> None:
        ...
global___AddTagsToBinaryDataByFilterRequest = AddTagsToBinaryDataByFilterRequest

@typing.final
class AddTagsToBinaryDataByFilterResponse(google.protobuf.message.Message):
    DESCRIPTOR: google.protobuf.descriptor.Descriptor

    def __init__(self) -> None:
        ...
global___AddTagsToBinaryDataByFilterResponse = AddTagsToBinaryDataByFilterResponse

@typing.final
class RemoveTagsFromBinaryDataByIDsRequest(google.protobuf.message.Message):
    """RemoveTagsFromBinaryDataByIDsRequest requests removing the given tags value from each file when binary ids are provided."""
    DESCRIPTOR: google.protobuf.descriptor.Descriptor
    BINARY_IDS_FIELD_NUMBER: builtins.int
    BINARY_DATA_IDS_FIELD_NUMBER: builtins.int
    TAGS_FIELD_NUMBER: builtins.int

    @property
    def binary_ids(self) -> google.protobuf.internal.containers.RepeatedCompositeFieldContainer[global___BinaryID]:
        ...

    @property
    def binary_data_ids(self) -> google.protobuf.internal.containers.RepeatedScalarFieldContainer[builtins.str]:
        ...

    @property
    def tags(self) -> google.protobuf.internal.containers.RepeatedScalarFieldContainer[builtins.str]:
        ...

    def __init__(self, *, binary_ids: collections.abc.Iterable[global___BinaryID] | None=..., binary_data_ids: collections.abc.Iterable[builtins.str] | None=..., tags: collections.abc.Iterable[builtins.str] | None=...) -> None:
        ...

    def ClearField(self, field_name: typing.Literal['binary_data_ids', b'binary_data_ids', 'binary_ids', b'binary_ids', 'tags', b'tags']) -> None:
        ...
global___RemoveTagsFromBinaryDataByIDsRequest = RemoveTagsFromBinaryDataByIDsRequest

@typing.final
class RemoveTagsFromBinaryDataByIDsResponse(google.protobuf.message.Message):
    """RemoveTagsFromBinaryDataByIDsResponse returns the number of binary files which had tags removed"""
    DESCRIPTOR: google.protobuf.descriptor.Descriptor
    DELETED_COUNT_FIELD_NUMBER: builtins.int
    deleted_count: builtins.int

    def __init__(self, *, deleted_count: builtins.int=...) -> None:
        ...

    def ClearField(self, field_name: typing.Literal['deleted_count', b'deleted_count']) -> None:
        ...
global___RemoveTagsFromBinaryDataByIDsResponse = RemoveTagsFromBinaryDataByIDsResponse

@typing.final
class RemoveTagsFromBinaryDataByFilterRequest(google.protobuf.message.Message):
    """RemoveTagsFromBinaryDataByFilterRequest requests removing the given tags value from each file when a filter is provided."""
    DESCRIPTOR: google.protobuf.descriptor.Descriptor
    FILTER_FIELD_NUMBER: builtins.int
    TAGS_FIELD_NUMBER: builtins.int

    @property
    def filter(self) -> global___Filter:
        ...

    @property
    def tags(self) -> google.protobuf.internal.containers.RepeatedScalarFieldContainer[builtins.str]:
        ...

    def __init__(self, *, filter: global___Filter | None=..., tags: collections.abc.Iterable[builtins.str] | None=...) -> None:
        ...

    def HasField(self, field_name: typing.Literal['filter', b'filter']) -> builtins.bool:
        ...

    def ClearField(self, field_name: typing.Literal['filter', b'filter', 'tags', b'tags']) -> None:
        ...
global___RemoveTagsFromBinaryDataByFilterRequest = RemoveTagsFromBinaryDataByFilterRequest

@typing.final
class RemoveTagsFromBinaryDataByFilterResponse(google.protobuf.message.Message):
    """RemoveTagsFromBinaryDataByFilterResponse returns the number of binary files which had tags removed."""
    DESCRIPTOR: google.protobuf.descriptor.Descriptor
    DELETED_COUNT_FIELD_NUMBER: builtins.int
    deleted_count: builtins.int

    def __init__(self, *, deleted_count: builtins.int=...) -> None:
        ...

    def ClearField(self, field_name: typing.Literal['deleted_count', b'deleted_count']) -> None:
        ...
global___RemoveTagsFromBinaryDataByFilterResponse = RemoveTagsFromBinaryDataByFilterResponse

@typing.final
class TagsByFilterRequest(google.protobuf.message.Message):
    """TagsByFilterRequest requests the unique tags from data based on given filter."""
    DESCRIPTOR: google.protobuf.descriptor.Descriptor
    FILTER_FIELD_NUMBER: builtins.int

    @property
    def filter(self) -> global___Filter:
        ...

    def __init__(self, *, filter: global___Filter | None=...) -> None:
        ...

    def HasField(self, field_name: typing.Literal['filter', b'filter']) -> builtins.bool:
        ...

    def ClearField(self, field_name: typing.Literal['filter', b'filter']) -> None:
        ...
global___TagsByFilterRequest = TagsByFilterRequest

@typing.final
class TagsByFilterResponse(google.protobuf.message.Message):
    """TagsByFilterResponse returns the unique tags from data based on given filter."""
    DESCRIPTOR: google.protobuf.descriptor.Descriptor
    TAGS_FIELD_NUMBER: builtins.int

    @property
    def tags(self) -> google.protobuf.internal.containers.RepeatedScalarFieldContainer[builtins.str]:
        ...

    def __init__(self, *, tags: collections.abc.Iterable[builtins.str] | None=...) -> None:
        ...

    def ClearField(self, field_name: typing.Literal['tags', b'tags']) -> None:
        ...
global___TagsByFilterResponse = TagsByFilterResponse

@typing.final
class AddBoundingBoxToImageByIDRequest(google.protobuf.message.Message):
    """AddBoundingBoxToImageByIDRequest specifies the binary ID to which a bounding box
    with the associated label and position in normalized coordinates will be added.
    """
    DESCRIPTOR: google.protobuf.descriptor.Descriptor
    BINARY_ID_FIELD_NUMBER: builtins.int
    BINARY_DATA_ID_FIELD_NUMBER: builtins.int
    LABEL_FIELD_NUMBER: builtins.int
    X_MIN_NORMALIZED_FIELD_NUMBER: builtins.int
    Y_MIN_NORMALIZED_FIELD_NUMBER: builtins.int
    X_MAX_NORMALIZED_FIELD_NUMBER: builtins.int
    Y_MAX_NORMALIZED_FIELD_NUMBER: builtins.int
    binary_data_id: builtins.str
    label: builtins.str
    x_min_normalized: builtins.float
    y_min_normalized: builtins.float
    x_max_normalized: builtins.float
    y_max_normalized: builtins.float

    @property
    def binary_id(self) -> global___BinaryID:
        ...

    def __init__(self, *, binary_id: global___BinaryID | None=..., binary_data_id: builtins.str=..., label: builtins.str=..., x_min_normalized: builtins.float=..., y_min_normalized: builtins.float=..., x_max_normalized: builtins.float=..., y_max_normalized: builtins.float=...) -> None:
        ...

    def HasField(self, field_name: typing.Literal['binary_id', b'binary_id']) -> builtins.bool:
        ...

    def ClearField(self, field_name: typing.Literal['binary_data_id', b'binary_data_id', 'binary_id', b'binary_id', 'label', b'label', 'x_max_normalized', b'x_max_normalized', 'x_min_normalized', b'x_min_normalized', 'y_max_normalized', b'y_max_normalized', 'y_min_normalized', b'y_min_normalized']) -> None:
        ...
global___AddBoundingBoxToImageByIDRequest = AddBoundingBoxToImageByIDRequest

@typing.final
class AddBoundingBoxToImageByIDResponse(google.protobuf.message.Message):
    """AddBoundingBoxToImageByIDResponse returns the bounding box ID of the successfully added bounding box."""
    DESCRIPTOR: google.protobuf.descriptor.Descriptor
    BBOX_ID_FIELD_NUMBER: builtins.int
    bbox_id: builtins.str

    def __init__(self, *, bbox_id: builtins.str=...) -> None:
        ...

    def ClearField(self, field_name: typing.Literal['bbox_id', b'bbox_id']) -> None:
        ...
global___AddBoundingBoxToImageByIDResponse = AddBoundingBoxToImageByIDResponse

@typing.final
class RemoveBoundingBoxFromImageByIDRequest(google.protobuf.message.Message):
    """RemoveBoundingBoxFromImageByIDRequest removes the bounding box with specified bounding box ID for the file represented by the binary ID."""
    DESCRIPTOR: google.protobuf.descriptor.Descriptor
    BINARY_ID_FIELD_NUMBER: builtins.int
    BINARY_DATA_ID_FIELD_NUMBER: builtins.int
    BBOX_ID_FIELD_NUMBER: builtins.int
    binary_data_id: builtins.str
    bbox_id: builtins.str

    @property
    def binary_id(self) -> global___BinaryID:
        ...

    def __init__(self, *, binary_id: global___BinaryID | None=..., binary_data_id: builtins.str=..., bbox_id: builtins.str=...) -> None:
        ...

    def HasField(self, field_name: typing.Literal['binary_id', b'binary_id']) -> builtins.bool:
        ...

    def ClearField(self, field_name: typing.Literal['bbox_id', b'bbox_id', 'binary_data_id', b'binary_data_id', 'binary_id', b'binary_id']) -> None:
        ...
global___RemoveBoundingBoxFromImageByIDRequest = RemoveBoundingBoxFromImageByIDRequest

@typing.final
class RemoveBoundingBoxFromImageByIDResponse(google.protobuf.message.Message):
    DESCRIPTOR: google.protobuf.descriptor.Descriptor

    def __init__(self) -> None:
        ...
global___RemoveBoundingBoxFromImageByIDResponse = RemoveBoundingBoxFromImageByIDResponse

@typing.final
class UpdateBoundingBoxRequest(google.protobuf.message.Message):
    """UpdateBoundingBoxRequest updates the bounding box with specified bounding box ID for the file represented by the binary ID."""
    DESCRIPTOR: google.protobuf.descriptor.Descriptor
    BINARY_ID_FIELD_NUMBER: builtins.int
    BINARY_DATA_ID_FIELD_NUMBER: builtins.int
    BBOX_ID_FIELD_NUMBER: builtins.int
    LABEL_FIELD_NUMBER: builtins.int
    X_MIN_NORMALIZED_FIELD_NUMBER: builtins.int
    Y_MIN_NORMALIZED_FIELD_NUMBER: builtins.int
    X_MAX_NORMALIZED_FIELD_NUMBER: builtins.int
    Y_MAX_NORMALIZED_FIELD_NUMBER: builtins.int
    binary_data_id: builtins.str
    bbox_id: builtins.str
    label: builtins.str
    x_min_normalized: builtins.float
    y_min_normalized: builtins.float
    x_max_normalized: builtins.float
    y_max_normalized: builtins.float

    @property
    def binary_id(self) -> global___BinaryID:
        ...

    def __init__(self, *, binary_id: global___BinaryID | None=..., binary_data_id: builtins.str=..., bbox_id: builtins.str=..., label: builtins.str | None=..., x_min_normalized: builtins.float | None=..., y_min_normalized: builtins.float | None=..., x_max_normalized: builtins.float | None=..., y_max_normalized: builtins.float | None=...) -> None:
        ...

    def HasField(self, field_name: typing.Literal['_label', b'_label', '_x_max_normalized', b'_x_max_normalized', '_x_min_normalized', b'_x_min_normalized', '_y_max_normalized', b'_y_max_normalized', '_y_min_normalized', b'_y_min_normalized', 'binary_id', b'binary_id', 'label', b'label', 'x_max_normalized', b'x_max_normalized', 'x_min_normalized', b'x_min_normalized', 'y_max_normalized', b'y_max_normalized', 'y_min_normalized', b'y_min_normalized']) -> builtins.bool:
        ...

    def ClearField(self, field_name: typing.Literal['_label', b'_label', '_x_max_normalized', b'_x_max_normalized', '_x_min_normalized', b'_x_min_normalized', '_y_max_normalized', b'_y_max_normalized', '_y_min_normalized', b'_y_min_normalized', 'bbox_id', b'bbox_id', 'binary_data_id', b'binary_data_id', 'binary_id', b'binary_id', 'label', b'label', 'x_max_normalized', b'x_max_normalized', 'x_min_normalized', b'x_min_normalized', 'y_max_normalized', b'y_max_normalized', 'y_min_normalized', b'y_min_normalized']) -> None:
        ...

    @typing.overload
    def WhichOneof(self, oneof_group: typing.Literal['_label', b'_label']) -> typing.Literal['label'] | None:
        ...

    @typing.overload
    def WhichOneof(self, oneof_group: typing.Literal['_x_max_normalized', b'_x_max_normalized']) -> typing.Literal['x_max_normalized'] | None:
        ...

    @typing.overload
    def WhichOneof(self, oneof_group: typing.Literal['_x_min_normalized', b'_x_min_normalized']) -> typing.Literal['x_min_normalized'] | None:
        ...

    @typing.overload
    def WhichOneof(self, oneof_group: typing.Literal['_y_max_normalized', b'_y_max_normalized']) -> typing.Literal['y_max_normalized'] | None:
        ...

    @typing.overload
    def WhichOneof(self, oneof_group: typing.Literal['_y_min_normalized', b'_y_min_normalized']) -> typing.Literal['y_min_normalized'] | None:
        ...
global___UpdateBoundingBoxRequest = UpdateBoundingBoxRequest

@typing.final
class UpdateBoundingBoxResponse(google.protobuf.message.Message):
    DESCRIPTOR: google.protobuf.descriptor.Descriptor

    def __init__(self) -> None:
        ...
global___UpdateBoundingBoxResponse = UpdateBoundingBoxResponse

@typing.final
class BoundingBoxLabelsByFilterRequest(google.protobuf.message.Message):
    """BoundingBoxLabelsByFilterRequest requests all the labels of the bounding boxes from files from a given filter."""
    DESCRIPTOR: google.protobuf.descriptor.Descriptor
    FILTER_FIELD_NUMBER: builtins.int

    @property
    def filter(self) -> global___Filter:
        ...

    def __init__(self, *, filter: global___Filter | None=...) -> None:
        ...

    def HasField(self, field_name: typing.Literal['filter', b'filter']) -> builtins.bool:
        ...

    def ClearField(self, field_name: typing.Literal['filter', b'filter']) -> None:
        ...
global___BoundingBoxLabelsByFilterRequest = BoundingBoxLabelsByFilterRequest

@typing.final
class BoundingBoxLabelsByFilterResponse(google.protobuf.message.Message):
    """BoundingBoxLabelsByFilterRequest returns all the labels of the bounding boxes from files from a given filter."""
    DESCRIPTOR: google.protobuf.descriptor.Descriptor
    LABELS_FIELD_NUMBER: builtins.int

    @property
    def labels(self) -> google.protobuf.internal.containers.RepeatedScalarFieldContainer[builtins.str]:
        ...

    def __init__(self, *, labels: collections.abc.Iterable[builtins.str] | None=...) -> None:
        ...

    def ClearField(self, field_name: typing.Literal['labels', b'labels']) -> None:
        ...
global___BoundingBoxLabelsByFilterResponse = BoundingBoxLabelsByFilterResponse

@typing.final
class ConfigureDatabaseUserRequest(google.protobuf.message.Message):
    """ConfigureDatabaseUserRequest accepts a Viam organization ID and a password for the database user
    being configured. Viam uses gRPC over TLS, so the entire request will be encrypted while in
    flight, including the password.
    """
    DESCRIPTOR: google.protobuf.descriptor.Descriptor
    ORGANIZATION_ID_FIELD_NUMBER: builtins.int
    PASSWORD_FIELD_NUMBER: builtins.int
    organization_id: builtins.str
    password: builtins.str

    def __init__(self, *, organization_id: builtins.str=..., password: builtins.str=...) -> None:
        ...

    def ClearField(self, field_name: typing.Literal['organization_id', b'organization_id', 'password', b'password']) -> None:
        ...
global___ConfigureDatabaseUserRequest = ConfigureDatabaseUserRequest

@typing.final
class ConfigureDatabaseUserResponse(google.protobuf.message.Message):
    DESCRIPTOR: google.protobuf.descriptor.Descriptor

    def __init__(self) -> None:
        ...
global___ConfigureDatabaseUserResponse = ConfigureDatabaseUserResponse

@typing.final
class GetDatabaseConnectionRequest(google.protobuf.message.Message):
    """GetDatabaseConnectionRequest requests the database connection hostname."""
    DESCRIPTOR: google.protobuf.descriptor.Descriptor
    ORGANIZATION_ID_FIELD_NUMBER: builtins.int
    organization_id: builtins.str

    def __init__(self, *, organization_id: builtins.str=...) -> None:
        ...

    def ClearField(self, field_name: typing.Literal['organization_id', b'organization_id']) -> None:
        ...
global___GetDatabaseConnectionRequest = GetDatabaseConnectionRequest

@typing.final
class GetDatabaseConnectionResponse(google.protobuf.message.Message):
    """GetDatabaseConnectionResponse returns the database connection hostname endpoint. It also returns
    a URI that can be used to connect to the database instance through MongoDB clients, as well as
    information on whether the Viam organization has a database user configured.
    """
    DESCRIPTOR: google.protobuf.descriptor.Descriptor
    HOSTNAME_FIELD_NUMBER: builtins.int
    MONGODB_URI_FIELD_NUMBER: builtins.int
    HAS_DATABASE_USER_FIELD_NUMBER: builtins.int
    hostname: builtins.str
    mongodb_uri: builtins.str
    has_database_user: builtins.bool

    def __init__(self, *, hostname: builtins.str=..., mongodb_uri: builtins.str=..., has_database_user: builtins.bool=...) -> None:
        ...

    def ClearField(self, field_name: typing.Literal['has_database_user', b'has_database_user', 'hostname', b'hostname', 'mongodb_uri', b'mongodb_uri']) -> None:
        ...
global___GetDatabaseConnectionResponse = GetDatabaseConnectionResponse

@typing.final
class AddBinaryDataToDatasetByIDsRequest(google.protobuf.message.Message):
    """AddBinaryDataToDatasetByIDsRequest adds the binary data with the given binary IDs to a dataset with dataset_id."""
    DESCRIPTOR: google.protobuf.descriptor.Descriptor
    BINARY_IDS_FIELD_NUMBER: builtins.int
    BINARY_DATA_IDS_FIELD_NUMBER: builtins.int
    DATASET_ID_FIELD_NUMBER: builtins.int
    dataset_id: builtins.str

    @property
    def binary_ids(self) -> google.protobuf.internal.containers.RepeatedCompositeFieldContainer[global___BinaryID]:
        ...

    @property
    def binary_data_ids(self) -> google.protobuf.internal.containers.RepeatedScalarFieldContainer[builtins.str]:
        ...

    def __init__(self, *, binary_ids: collections.abc.Iterable[global___BinaryID] | None=..., binary_data_ids: collections.abc.Iterable[builtins.str] | None=..., dataset_id: builtins.str=...) -> None:
        ...

    def ClearField(self, field_name: typing.Literal['binary_data_ids', b'binary_data_ids', 'binary_ids', b'binary_ids', 'dataset_id', b'dataset_id']) -> None:
        ...
global___AddBinaryDataToDatasetByIDsRequest = AddBinaryDataToDatasetByIDsRequest

@typing.final
class AddBinaryDataToDatasetByIDsResponse(google.protobuf.message.Message):
    DESCRIPTOR: google.protobuf.descriptor.Descriptor

    def __init__(self) -> None:
        ...
global___AddBinaryDataToDatasetByIDsResponse = AddBinaryDataToDatasetByIDsResponse

@typing.final
class RemoveBinaryDataFromDatasetByIDsRequest(google.protobuf.message.Message):
    """RemoveBinaryDataFromDatasetByIDsRequest removes the specified binary IDs from a dataset with dataset_id."""
    DESCRIPTOR: google.protobuf.descriptor.Descriptor
    BINARY_IDS_FIELD_NUMBER: builtins.int
    BINARY_DATA_IDS_FIELD_NUMBER: builtins.int
    DATASET_ID_FIELD_NUMBER: builtins.int
    dataset_id: builtins.str

    @property
    def binary_ids(self) -> google.protobuf.internal.containers.RepeatedCompositeFieldContainer[global___BinaryID]:
        ...

    @property
    def binary_data_ids(self) -> google.protobuf.internal.containers.RepeatedScalarFieldContainer[builtins.str]:
        ...

    def __init__(self, *, binary_ids: collections.abc.Iterable[global___BinaryID] | None=..., binary_data_ids: collections.abc.Iterable[builtins.str] | None=..., dataset_id: builtins.str=...) -> None:
        ...

    def ClearField(self, field_name: typing.Literal['binary_data_ids', b'binary_data_ids', 'binary_ids', b'binary_ids', 'dataset_id', b'dataset_id']) -> None:
        ...
global___RemoveBinaryDataFromDatasetByIDsRequest = RemoveBinaryDataFromDatasetByIDsRequest

@typing.final
class RemoveBinaryDataFromDatasetByIDsResponse(google.protobuf.message.Message):
    DESCRIPTOR: google.protobuf.descriptor.Descriptor

    def __init__(self) -> None:
        ...
global___RemoveBinaryDataFromDatasetByIDsResponse = RemoveBinaryDataFromDatasetByIDsResponse