"""
@generated by mypy-protobuf.  Do not edit manually!
isort:skip_file
"""
import builtins
import collections.abc
from .... import common
import google.protobuf.descriptor
import google.protobuf.internal.containers
import google.protobuf.message
import google.protobuf.struct_pb2
import typing
DESCRIPTOR: google.protobuf.descriptor.FileDescriptor

@typing.final
class GetEndPositionRequest(google.protobuf.message.Message):
    DESCRIPTOR: google.protobuf.descriptor.Descriptor
    NAME_FIELD_NUMBER: builtins.int
    EXTRA_FIELD_NUMBER: builtins.int
    name: builtins.str
    'Name of an arm'

    @property
    def extra(self) -> google.protobuf.struct_pb2.Struct:
        """Additional arguments to the method"""

    def __init__(self, *, name: builtins.str=..., extra: google.protobuf.struct_pb2.Struct | None=...) -> None:
        ...

    def HasField(self, field_name: typing.Literal['extra', b'extra']) -> builtins.bool:
        ...

    def ClearField(self, field_name: typing.Literal['extra', b'extra', 'name', b'name']) -> None:
        ...
global___GetEndPositionRequest = GetEndPositionRequest

@typing.final
class GetEndPositionResponse(google.protobuf.message.Message):
    DESCRIPTOR: google.protobuf.descriptor.Descriptor
    POSE_FIELD_NUMBER: builtins.int

    @property
    def pose(self) -> common.v1.common_pb2.Pose:
        """Returns 6d pose of the end effector relative to the base, represented by X,Y,Z coordinates which express
        millimeters and theta, ox, oy, oz coordinates which express an orientation vector
        """

    def __init__(self, *, pose: common.v1.common_pb2.Pose | None=...) -> None:
        ...

    def HasField(self, field_name: typing.Literal['pose', b'pose']) -> builtins.bool:
        ...

    def ClearField(self, field_name: typing.Literal['pose', b'pose']) -> None:
        ...
global___GetEndPositionResponse = GetEndPositionResponse

@typing.final
class JointPositions(google.protobuf.message.Message):
    DESCRIPTOR: google.protobuf.descriptor.Descriptor
    VALUES_FIELD_NUMBER: builtins.int

    @property
    def values(self) -> google.protobuf.internal.containers.RepeatedScalarFieldContainer[builtins.float]:
        """A list of joint positions. Rotations values are in degrees, translational values in mm.
        There should be 1 entry in the list per joint DOF, ordered spatially from the base toward the end effector of the arm
        """

    def __init__(self, *, values: collections.abc.Iterable[builtins.float] | None=...) -> None:
        ...

    def ClearField(self, field_name: typing.Literal['values', b'values']) -> None:
        ...
global___JointPositions = JointPositions

@typing.final
class GetJointPositionsRequest(google.protobuf.message.Message):
    DESCRIPTOR: google.protobuf.descriptor.Descriptor
    NAME_FIELD_NUMBER: builtins.int
    EXTRA_FIELD_NUMBER: builtins.int
    name: builtins.str
    'Name of an arm'

    @property
    def extra(self) -> google.protobuf.struct_pb2.Struct:
        """Additional arguments to the method"""

    def __init__(self, *, name: builtins.str=..., extra: google.protobuf.struct_pb2.Struct | None=...) -> None:
        ...

    def HasField(self, field_name: typing.Literal['extra', b'extra']) -> builtins.bool:
        ...

    def ClearField(self, field_name: typing.Literal['extra', b'extra', 'name', b'name']) -> None:
        ...
global___GetJointPositionsRequest = GetJointPositionsRequest

@typing.final
class GetJointPositionsResponse(google.protobuf.message.Message):
    DESCRIPTOR: google.protobuf.descriptor.Descriptor
    POSITIONS_FIELD_NUMBER: builtins.int

    @property
    def positions(self) -> global___JointPositions:
        """a list JointPositions"""

    def __init__(self, *, positions: global___JointPositions | None=...) -> None:
        ...

    def HasField(self, field_name: typing.Literal['positions', b'positions']) -> builtins.bool:
        ...

    def ClearField(self, field_name: typing.Literal['positions', b'positions']) -> None:
        ...
global___GetJointPositionsResponse = GetJointPositionsResponse

@typing.final
class MoveToPositionRequest(google.protobuf.message.Message):
    """Moves an arm to the specified pose that is within the reference frame of the arm.
    Move request in Motion API has the same behavior except that it performs obstacle avoidance when a world_state
    message is specified.
    """
    DESCRIPTOR: google.protobuf.descriptor.Descriptor
    NAME_FIELD_NUMBER: builtins.int
    TO_FIELD_NUMBER: builtins.int
    EXTRA_FIELD_NUMBER: builtins.int
    name: builtins.str
    'Name of an arm'

    @property
    def to(self) -> common.v1.common_pb2.Pose:
        """The destination to move the arm to; this is from the reference frame of the arm."""

    @property
    def extra(self) -> google.protobuf.struct_pb2.Struct:
        """Additional arguments to the method"""

    def __init__(self, *, name: builtins.str=..., to: common.v1.common_pb2.Pose | None=..., extra: google.protobuf.struct_pb2.Struct | None=...) -> None:
        ...

    def HasField(self, field_name: typing.Literal['extra', b'extra', 'to', b'to']) -> builtins.bool:
        ...

    def ClearField(self, field_name: typing.Literal['extra', b'extra', 'name', b'name', 'to', b'to']) -> None:
        ...
global___MoveToPositionRequest = MoveToPositionRequest

@typing.final
class MoveToPositionResponse(google.protobuf.message.Message):
    DESCRIPTOR: google.protobuf.descriptor.Descriptor

    def __init__(self) -> None:
        ...
global___MoveToPositionResponse = MoveToPositionResponse

@typing.final
class MoveToJointPositionsRequest(google.protobuf.message.Message):
    DESCRIPTOR: google.protobuf.descriptor.Descriptor
    NAME_FIELD_NUMBER: builtins.int
    POSITIONS_FIELD_NUMBER: builtins.int
    EXTRA_FIELD_NUMBER: builtins.int
    name: builtins.str
    'Name of an arm'

    @property
    def positions(self) -> global___JointPositions:
        """A list of joint positions
        There should be 1 entry in the list per joint DOF, ordered spatially from the base toward the end effector
        """

    @property
    def extra(self) -> google.protobuf.struct_pb2.Struct:
        """Additional arguments to the method"""

    def __init__(self, *, name: builtins.str=..., positions: global___JointPositions | None=..., extra: google.protobuf.struct_pb2.Struct | None=...) -> None:
        ...

    def HasField(self, field_name: typing.Literal['extra', b'extra', 'positions', b'positions']) -> builtins.bool:
        ...

    def ClearField(self, field_name: typing.Literal['extra', b'extra', 'name', b'name', 'positions', b'positions']) -> None:
        ...
global___MoveToJointPositionsRequest = MoveToJointPositionsRequest

@typing.final
class MoveToJointPositionsResponse(google.protobuf.message.Message):
    DESCRIPTOR: google.protobuf.descriptor.Descriptor

    def __init__(self) -> None:
        ...
global___MoveToJointPositionsResponse = MoveToJointPositionsResponse

@typing.final
class MoveThroughJointPositionsRequest(google.protobuf.message.Message):
    DESCRIPTOR: google.protobuf.descriptor.Descriptor
    NAME_FIELD_NUMBER: builtins.int
    POSITIONS_FIELD_NUMBER: builtins.int
    OPTIONS_FIELD_NUMBER: builtins.int
    EXTRA_FIELD_NUMBER: builtins.int
    name: builtins.str
    'Name of an arm'

    @property
    def positions(self) -> google.protobuf.internal.containers.RepeatedCompositeFieldContainer[global___JointPositions]:
        """A list of joint positions which will be moved to in the order they are specified"""

    @property
    def options(self) -> global___MoveOptions:
        """optional specifications to be obeyed during the motion"""

    @property
    def extra(self) -> google.protobuf.struct_pb2.Struct:
        """Additional arguments to the method"""

    def __init__(self, *, name: builtins.str=..., positions: collections.abc.Iterable[global___JointPositions] | None=..., options: global___MoveOptions | None=..., extra: google.protobuf.struct_pb2.Struct | None=...) -> None:
        ...

    def HasField(self, field_name: typing.Literal['_options', b'_options', 'extra', b'extra', 'options', b'options']) -> builtins.bool:
        ...

    def ClearField(self, field_name: typing.Literal['_options', b'_options', 'extra', b'extra', 'name', b'name', 'options', b'options', 'positions', b'positions']) -> None:
        ...

    def WhichOneof(self, oneof_group: typing.Literal['_options', b'_options']) -> typing.Literal['options'] | None:
        ...
global___MoveThroughJointPositionsRequest = MoveThroughJointPositionsRequest

@typing.final
class MoveThroughJointPositionsResponse(google.protobuf.message.Message):
    DESCRIPTOR: google.protobuf.descriptor.Descriptor

    def __init__(self) -> None:
        ...
global___MoveThroughJointPositionsResponse = MoveThroughJointPositionsResponse

@typing.final
class StopRequest(google.protobuf.message.Message):
    DESCRIPTOR: google.protobuf.descriptor.Descriptor
    NAME_FIELD_NUMBER: builtins.int
    EXTRA_FIELD_NUMBER: builtins.int
    name: builtins.str
    'Name of an arm'

    @property
    def extra(self) -> google.protobuf.struct_pb2.Struct:
        """Additional arguments to the method"""

    def __init__(self, *, name: builtins.str=..., extra: google.protobuf.struct_pb2.Struct | None=...) -> None:
        ...

    def HasField(self, field_name: typing.Literal['extra', b'extra']) -> builtins.bool:
        ...

    def ClearField(self, field_name: typing.Literal['extra', b'extra', 'name', b'name']) -> None:
        ...
global___StopRequest = StopRequest

@typing.final
class StopResponse(google.protobuf.message.Message):
    DESCRIPTOR: google.protobuf.descriptor.Descriptor

    def __init__(self) -> None:
        ...
global___StopResponse = StopResponse

@typing.final
class Status(google.protobuf.message.Message):
    DESCRIPTOR: google.protobuf.descriptor.Descriptor
    END_POSITION_FIELD_NUMBER: builtins.int
    JOINT_POSITIONS_FIELD_NUMBER: builtins.int
    IS_MOVING_FIELD_NUMBER: builtins.int
    is_moving: builtins.bool

    @property
    def end_position(self) -> common.v1.common_pb2.Pose:
        ...

    @property
    def joint_positions(self) -> global___JointPositions:
        ...

    def __init__(self, *, end_position: common.v1.common_pb2.Pose | None=..., joint_positions: global___JointPositions | None=..., is_moving: builtins.bool=...) -> None:
        ...

    def HasField(self, field_name: typing.Literal['end_position', b'end_position', 'joint_positions', b'joint_positions']) -> builtins.bool:
        ...

    def ClearField(self, field_name: typing.Literal['end_position', b'end_position', 'is_moving', b'is_moving', 'joint_positions', b'joint_positions']) -> None:
        ...
global___Status = Status

@typing.final
class IsMovingRequest(google.protobuf.message.Message):
    DESCRIPTOR: google.protobuf.descriptor.Descriptor
    NAME_FIELD_NUMBER: builtins.int
    name: builtins.str

    def __init__(self, *, name: builtins.str=...) -> None:
        ...

    def ClearField(self, field_name: typing.Literal['name', b'name']) -> None:
        ...
global___IsMovingRequest = IsMovingRequest

@typing.final
class IsMovingResponse(google.protobuf.message.Message):
    DESCRIPTOR: google.protobuf.descriptor.Descriptor
    IS_MOVING_FIELD_NUMBER: builtins.int
    is_moving: builtins.bool

    def __init__(self, *, is_moving: builtins.bool=...) -> None:
        ...

    def ClearField(self, field_name: typing.Literal['is_moving', b'is_moving']) -> None:
        ...
global___IsMovingResponse = IsMovingResponse

@typing.final
class MoveOptions(google.protobuf.message.Message):
    DESCRIPTOR: google.protobuf.descriptor.Descriptor
    MAX_VEL_DEGS_PER_SEC_FIELD_NUMBER: builtins.int
    MAX_ACC_DEGS_PER_SEC2_FIELD_NUMBER: builtins.int
    max_vel_degs_per_sec: builtins.float
    'Maximum allowable velocity of an arm joint, in degrees per second'
    max_acc_degs_per_sec2: builtins.float
    'Maximum allowable acceleration of an arm joint, in degrees per second squared'

    def __init__(self, *, max_vel_degs_per_sec: builtins.float | None=..., max_acc_degs_per_sec2: builtins.float | None=...) -> None:
        ...

    def HasField(self, field_name: typing.Literal['_max_acc_degs_per_sec2', b'_max_acc_degs_per_sec2', '_max_vel_degs_per_sec', b'_max_vel_degs_per_sec', 'max_acc_degs_per_sec2', b'max_acc_degs_per_sec2', 'max_vel_degs_per_sec', b'max_vel_degs_per_sec']) -> builtins.bool:
        ...

    def ClearField(self, field_name: typing.Literal['_max_acc_degs_per_sec2', b'_max_acc_degs_per_sec2', '_max_vel_degs_per_sec', b'_max_vel_degs_per_sec', 'max_acc_degs_per_sec2', b'max_acc_degs_per_sec2', 'max_vel_degs_per_sec', b'max_vel_degs_per_sec']) -> None:
        ...

    @typing.overload
    def WhichOneof(self, oneof_group: typing.Literal['_max_acc_degs_per_sec2', b'_max_acc_degs_per_sec2']) -> typing.Literal['max_acc_degs_per_sec2'] | None:
        ...

    @typing.overload
    def WhichOneof(self, oneof_group: typing.Literal['_max_vel_degs_per_sec', b'_max_vel_degs_per_sec']) -> typing.Literal['max_vel_degs_per_sec'] | None:
        ...
global___MoveOptions = MoveOptions